export var TreeEditor;
(function (TreeEditor) {
    var RootNode;
    (function (RootNode) {
        function is(node) {
            return !!node;
        }
        RootNode.is = is;
    })(RootNode = TreeEditor.RootNode || (TreeEditor.RootNode = {}));
    var Node;
    (function (Node) {
        function is(node) {
            if (!!node && 'jsonforms' in node) {
                var jsonforms = node.jsonforms;
                return !!jsonforms;
            }
            return false;
        }
        Node.is = is;
        function hasType(node, type) {
            return is(node) && node.jsonforms.type === type;
        }
        Node.hasType = hasType;
    })(Node = TreeEditor.Node || (TreeEditor.Node = {}));
    /**
     * Label provider for the tree providing icons and display names for tree nodes.
     */
    TreeEditor.LabelProvider = Symbol('LabelProvider');
    TreeEditor.ModelService = Symbol('JsonFormsModelService');
    /**
     * Encapsulates logic to create the tree nodes from the tree's input data.
     */
    TreeEditor.NodeFactory = Symbol('NodeFactory');
})(TreeEditor || (TreeEditor = {}));
//# sourceMappingURL=interfaces.js.map