/********************************************************************************
 * Copyright (c) 2019 EclipseSource and others.
 *
 * This program and the accompanying materials are made available under the
 * terms of the Eclipse Public License v. 2.0 which is available at
 * https://www.eclipse.org/legal/epl-2.0, or the MIT License which is
 * available at https://opensource.org/licenses/MIT.
 *
 * SPDX-License-Identifier: EPL-2.0 OR MIT
 ********************************************************************************/
import { CommandContribution, CommandRegistry, MenuContribution, MenuModelRegistry } from '@theia/core';
import { WidgetOpenHandler } from '@theia/core/lib/browser';
import { TreeEditor } from './interfaces';
import { JsonFormsTreeEditorWidget } from './tree-editor-widget';
export declare abstract class JsonFormsTreeEditorContribution extends WidgetOpenHandler<JsonFormsTreeEditorWidget> implements CommandContribution, MenuContribution {
    private modelService;
    private labelProvider;
    private commandMap;
    constructor(modelService: TreeEditor.ModelService, labelProvider: TreeEditor.LabelProvider);
    /**
     * @returns maps property name to EClass identifiers to their corresponding add command
     */
    private getCommandMap;
    registerCommands(commands: CommandRegistry): void;
    registerMenus(menus: MenuModelRegistry): void;
}
