var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
import { WidgetOpenHandler } from '@theia/core/lib/browser';
import { JsonFormsTreeContextMenu } from './tree-widget';
import { generateAddCommands } from './util';
var JsonFormsTreeEditorContribution = /** @class */ (function (_super) {
    __extends(JsonFormsTreeEditorContribution, _super);
    function JsonFormsTreeEditorContribution(modelService, labelProvider) {
        var _this = _super.call(this) || this;
        _this.modelService = modelService;
        _this.labelProvider = labelProvider;
        return _this;
    }
    /**
     * @returns maps property name to EClass identifiers to their corresponding add command
     */
    JsonFormsTreeEditorContribution.prototype.getCommandMap = function () {
        if (!this.commandMap) {
            this.commandMap = generateAddCommands(this.modelService);
        }
        return this.commandMap;
    };
    JsonFormsTreeEditorContribution.prototype.registerCommands = function (commands) {
        var _this = this;
        this.getCommandMap().forEach(function (value, property, _map) {
            value.forEach(function (command, eClass) { return commands.registerCommand(command, new AddCommandHandler(property, eClass, _this.modelService)); });
        });
    };
    JsonFormsTreeEditorContribution.prototype.registerMenus = function (menus) {
        var _this = this;
        this.getCommandMap().forEach(function (value, _property, _map) {
            value.forEach(function (command, eClass) {
                menus.registerMenuAction(JsonFormsTreeContextMenu.ADD_MENU, {
                    commandId: command.id,
                    label: command.label,
                    icon: _this.labelProvider.getIconClass(eClass)
                });
            });
        });
    };
    return JsonFormsTreeEditorContribution;
}(WidgetOpenHandler));
export { JsonFormsTreeEditorContribution };
var AddCommandHandler = /** @class */ (function () {
    function AddCommandHandler(property, type, modelService) {
        this.property = property;
        this.type = type;
        this.modelService = modelService;
    }
    AddCommandHandler.prototype.execute = function (treeAnchor) {
        treeAnchor.onClick(this.property, this.type);
    };
    AddCommandHandler.prototype.isVisible = function (treeAnchor) {
        if (!treeAnchor) {
            return false;
        }
        return this.modelService.getChildrenMapping().get(treeAnchor.node.jsonforms.type)
            .map(function (desc) { return desc.children; })
            .reduce(function (acc, val) { return acc.concat(val); }, [])
            .reduce(function (acc, val) { return acc.add(val); }, new Set())
            .has(this.type);
    };
    return AddCommandHandler;
}());
//# sourceMappingURL=tree-editor-contribution.js.map